import {DataParser} from "./DataParser";
import {HeroCfg} from "../cfg/parsers/HeroCfg";
import {UnitCfg} from "../cfg/parsers/UnitCfg";
import {BaseConst} from "../constants/BaseConst";
import {FormulaCfg} from "../cfg/parsers/FormulaCfg";
import { DropItemCfg } from '../cfg/parsers/DropItemCfg'
import { ItemCardCfg } from '../cfg/parsers/ItemCardCfg'
import { MatchCfg } from '../cfg/parsers/MatchCfg'
import { ItemFuncCfg } from '../cfg/parsers/ItemFuncCfg'
import ItemCtrl from "../logic/ItemCtrl";
import { EffectCardCfg } from '../cfg/parsers/EffectCardCfg'
import { IncomeCfg } from '../cfg/parsers/IncomeCfg'
import { BaseCfg } from '../cfg/parsers/BaseCfg'


export function initData() {
    const rP = DataParser.regCommonParser.bind(DataParser);
    rP(BaseConst.COMPOUND, BaseCfg)
    rP(BaseConst.HERO, HeroCfg);
    rP(BaseConst.UNIT, UnitCfg);
    rP(BaseConst.EFFECTCARD, EffectCardCfg);
    rP(BaseConst.FORMULA, FormulaCfg);
    rP(BaseConst.DROPITEM, DropItemCfg);
    rP(BaseConst.ITEMCARD, ItemCardCfg);
    rP(BaseConst.MATCH, MatchCfg);
    rP(BaseConst.ITEMFUNC, ItemFuncCfg);
    rP(BaseConst.INCOME, IncomeCfg);
    DataParser.loadAll();
    ItemCtrl.initItems();
}

