import BaseController from '../common/base.controller'
import { router } from '../decorators/router'
import { getAttachment } from '../service/mail'
import { ZError } from '../common/ZError'
import { BagItem, getItemType } from '../models/BagItem'
import ItemCtrl from '../logic/ItemCtrl'
import { ItemInfo } from '../logic/ItemDef'

export default class MailController extends BaseController {

  @router('post /api/:accountid/mail_attachment')
  async receiveAttachment(req: any) {
    let { accountid, sessionid, mailids } = req.params
    let { data } = await getAttachment(accountid, sessionid, mailids)
    if (data.errcode) {
      throw new ZError(data.errcode, data.errmsg)
    }
    let items: ItemInfo[] = []
    if (data.attachments && data.attachments.length > 0) {
      let itemStr = ''
      for (let i = 0; i < data.attachments.length; i++) {
        const obj = data.attachments[i]
        if (i > 0) itemStr += '|'
        itemStr += `${obj.itemid}:${obj.itemnum}`
      }
      items = ItemCtrl.getItemsByInfo(itemStr)
      await BagItem.addItems(accountid, items, 'mail', mailids)
    }
    return items
  }

}
