import { singleton } from '../decorators/singleton.decorator'

const MAX_SEC = 30
@singleton
export class RobotDao {
  accountSet: Map<string, number>
  constructor() {
    this.accountSet = new Map()
  }

  setGameing(key: string) {
    let now = Date.now() / 1000 | 0
    this.accountSet.set(key, now)
  }
  checkGameing(key: string) {
    let now = Date.now() / 1000 | 0
    for(let [key, sec] of this.accountSet) {
      if (now - sec >= MAX_SEC) {
        this.accountSet.delete(key)
      }
    }
    let result = this.accountSet.has(key)
    if (!result) {
      this.accountSet.set(key, now)
    }
    return result
  }
}
