import { dbconn } from '../decorators/dbconn'
import {
  getModelForClass,
  index,
  modelOptions,
  plugin,
  prop
} from '@typegoose/typegoose'
import {
  Base,
  FindOrCreate,
  TimeStamps
} from '@typegoose/typegoose/lib/defaultClasses'
// @ts-ignore
import findOrCreate from 'mongoose-findorcreate'


interface ActRecordClass extends Base<string>, TimeStamps {
}

@dbconn()
@index({ 'accountid': 1 , 'actid': 1,  'day': 1}, { unique: true })
@plugin(findOrCreate)
@modelOptions({
  schemaOptions:
    { collection: 'act_record', timestamps: true }
})
class ActRecordClass extends FindOrCreate {
  @prop()
  public accountid: string

  @prop()
  public actid: string

  @prop()
  public day: string

  @prop({ default: 0 })
  public count: number

  @prop({default: Date.now()})
  public lasttime: number

}

export const ActRecord = getModelForClass(ActRecordClass,
// @ts-ignore
  { existingConnection: ActRecordClass['db'] })
