import { dbconn } from '../decorators/dbconn'
import {
  getModelForClass,
  index,
  modelOptions, plugin,
  prop
} from '@typegoose/typegoose'
import {
  Base,
  FindOrCreate,
  TimeStamps
} from '@typegoose/typegoose/lib/defaultClasses'
// @ts-ignore
import findOrCreate from 'mongoose-findorcreate'
import { Card } from './subdoc/Card'

interface SignRecordClass extends Base<string>, TimeStamps {
}

@dbconn()
@plugin(findOrCreate)
@index({ accountid: 1 }, { unique: false })
@modelOptions({
  schemaOptions:
    { collection: 'sign_record', timestamps: true }
})
class SignRecordClass extends FindOrCreate{
  @prop({ required: true })
  public accountid!: string
  @prop({default: 0})
  public last: number
  // 0 未完成，3 已完成
  @prop({ type: Number, default: new Map() })
  public data: Map<string, number>

  @prop({default: 0})
  public double: number
  public toJson() {
    return {
      accoundid: this.accountid,
      last: this.last,
      data: this.data
    }
  }
}

export const SignRecord = getModelForClass(SignRecordClass,
// @ts-ignore
  { existingConnection: SignRecordClass['db'] })
