import { singleton } from '../decorators/singleton.decorator'
import { getGameConfig } from './jcfw'

@singleton
export class SvrConfig {
  public cfgMap: Map<string, any> = new Map()

  public async loadData(gameid: string, channel: string) {
    const cfgs = await getGameConfig(gameid, channel)
    let map: Map<string, any> = new Map()
    for (let cfg of cfgs) {
      try {
        let obj = JSON.parse(cfg.value)
        map.set(cfg.key, obj)
      } catch(e) {
        map.set(cfg.key, cfg.value)
      }
    }
    this.cfgMap.set(SvrConfig.generateKey(gameid, channel), map)
  }
  public static generateKey(gameid: string, channel: string) {
    return `${gameid}_${channel}`
  }

  public async getSignCfg(gameid: string, channel: string) {
    let key = SvrConfig.generateKey(gameid, channel)
    if (!this.cfgMap.has(key)) {
      await this.loadData(gameid, channel)
    }
    return this.cfgMap.get(key).get('sign_list')
  }


}
