import axios from 'axios'
import { generateKeyValStr } from '../utils/string.util'

const isProd = process.env.NODE_ENV === 'production'
const MAIL_ATTACHMENT_URL = `https://gamemail${isProd ? '' : '-test'}.kingsome.cn/webapp/index.php?c=Mail&a=getAttachment`

/**
 * 领取邮件附件
 * @param {string} session_id
 * @param {string} account_id
 * @param {string} mail_ids
 * @return {Promise<AxiosResponse<any>>}
 */
export function getAttachment(account_id: string, session_id: string, mail_ids: string) {
  let data = { session_id, account_id, mail_ids }
  let paramStr = generateKeyValStr(data);
  let url = `${MAIL_ATTACHMENT_URL}&${paramStr}`
  return axios.get(url)
}
