/**
 * 根据key升序生成 key1=val1&key2=val2的字符串
 * @param {object} data 需要处理的对象
 * @param {boolean} ignoreNull 是否过滤空值(空格或者null值不参与拼接)
 * @param splitChar 连接的字符, 默认是&
 * @param equalChar =
 */
export function generateKeyValStr(data: any,
                                  ignoreNull = true,
                                  splitChar: string = '&',
                                  equalChar = '='): string {
  const keys = Object.keys(data)
  keys.sort()
  let result = ''
  let i = 0
  for (let key of keys) {
    if (ignoreNull && !data[key]) {
      continue
    }
    if (i++ > 0) result += splitChar
    result += `${ key }${ equalChar }${ data[key] }`
  }
  return result
}

/**
 * 将key1=val&key2=val的字符串组装成对象
 * @param str key1=val&key2=val的字符串
 * @param splitChar 连接的字符, 默认是&
 * @param equalChar =
 */
export function keyValToObject(str: string,
                               splitChar: string = '&',
                               equalChar = '='): {} {
  let result: any = {}
  if (!str) {
    return result
  }
  let arrs = str.split(splitChar)
  for (let sub of arrs) {
    let subArr = sub.split(equalChar)
    result[subArr[0]] = subArr[1]
  }
  return result
}

export function isJsonString(str: string) {
  try {
    if (typeof JSON.parse(str) == "object") {
      return true;
    }
  } catch(e) {
  }
  return false;
}

export function checkAccountId(accountId: string) {
  return /^\d{4}_\d{4}_.+$/.test(accountId);
}
export function parseGameAccountId(accountId: string) {
  const arr = accountId.split('_');
  const gameid = arr[1];
  const channel = arr[0];
  return {gameid, channel};
}
